__  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

[email protected]: ~ $
#!/bin/bash
# perf trace BTF general tests
# SPDX-License-Identifier: GPL-2.0

err=0
set -e

# shellcheck source=lib/probe.sh
. "$(dirname $0)"/lib/probe.sh

file1=$(mktemp /tmp/file1_XXXX)
file2=$(echo $file1 | sed 's/file1/file2/g')

buffer="buffer content"
perf_config_tmp=$(mktemp /tmp/.perfconfig_XXXXX)

trap cleanup EXIT TERM INT HUP

check_vmlinux() {
  echo "Checking if vmlinux BTF exists"
  if [ ! -f /sys/kernel/btf/vmlinux ]
  then
    echo "Skipped due to missing vmlinux BTF"
    return 2
  fi
  return 0
}

trace_test_string() {
  echo "Testing perf trace's string augmentation"
  if ! perf trace -e renameat* --max-events=1 -- mv ${file1} ${file2} 2>&1 | \
    grep -q -E "^mv/[0-9]+ renameat(2)?\(.*, \"${file1}\", .*, \"${file2}\", .*\) += +[0-9]+$"
  then
    echo "String augmentation test failed"
    err=1
  fi
}

trace_test_buffer() {
  echo "Testing perf trace's buffer augmentation"
  # echo will insert a newline (\10) at the end of the buffer
  if ! perf trace -e write --max-events=1 -- echo "${buffer}" 2>&1 | \
    grep -q -E "^echo/[0-9]+ write\([0-9]+, ${buffer}.*, [0-9]+\) += +[0-9]+$"
  then
    echo "Buffer augmentation test failed"
    err=1
  fi
}

trace_test_struct_btf() {
  echo "Testing perf trace's struct augmentation"
  if ! perf trace -e clock_nanosleep --force-btf --max-events=1 -- sleep 1 2>&1 | \
    grep -q -E "^sleep/[0-9]+ clock_nanosleep\(0, 0, \{1,\}, 0x[0-9a-f]+\) += +[0-9]+$"
  then
    echo "BTF struct augmentation test failed"
    err=1
  fi
}

cleanup() {
  rm -rf ${file1} ${file2} ${perf_config_tmp}
}

trap_cleanup() {
  echo "Unexpected signal in ${FUNCNAME[1]}"
  cleanup
  exit 1
}

# don't overwrite user's perf config
trace_config() {
  export PERF_CONFIG=${perf_config_tmp}
  perf config trace.show_arg_names=false trace.show_duration=false \
    trace.show_timestamp=false trace.args_alignment=0
}

skip_if_no_perf_trace || exit 2
check_vmlinux || exit 2

trace_config

trace_test_string

if [ $err = 0 ]; then
  trace_test_buffer
fi

if [ $err = 0 ]; then
  trace_test_struct_btf
fi

cleanup

exit $err

Filemanager

Name Type Size Permission Actions
base_probe Folder 0755
base_report Folder 0755
common Folder 0755
coresight Folder 0755
lib Folder 0755
annotate.sh File 2.08 KB 0755
attr.sh File 385 B 0755
buildid.sh File 4.15 KB 0755
daemon.sh File 11.31 KB 0755
diff.sh File 1.93 KB 0755
ftrace.sh File 2.22 KB 0755
list.sh File 756 B 0755
lock_contention.sh File 8.9 KB 0755
perftool-testsuite_probe.sh File 575 B 0755
perftool-testsuite_report.sh File 578 B 0755
pipe_test.sh File 3.22 KB 0755
probe_vfs_getname.sh File 440 B 0755
record+probe_libc_inet_pton.sh File 3.43 KB 0755
record+script_probe_vfs_getname.sh File 1.53 KB 0755
record+zstd_comp_decomp.sh File 1.12 KB 0755
record.sh File 8.27 KB 0755
record_bpf_filter.sh File 4.37 KB 0755
record_lbr.sh File 3.46 KB 0755
record_offcpu.sh File 2.07 KB 0755
record_sideband.sh File 1.07 KB 0755
script.sh File 2.01 KB 0755
stat+csv_output.sh File 2 KB 0755
stat+csv_summary.sh File 611 B 0755
stat+json_output.sh File 5.02 KB 0755
stat+shadow_stat.sh File 2.08 KB 0755
stat+std_output.sh File 2.96 KB 0755
stat.sh File 6.36 KB 0755
stat_all_metricgroups.sh File 1016 B 0755
stat_all_metrics.sh File 1.83 KB 0755
stat_all_pfm.sh File 1.17 KB 0755
stat_all_pmu.sh File 1.73 KB 0755
stat_bpf_counters.sh File 2 KB 0755
stat_bpf_counters_cgrp.sh File 1.66 KB 0755
stat_metrics_values.sh File 844 B 0755
test_arm_callgraph_fp.sh File 1.18 KB 0755
test_arm_coresight.sh File 5.7 KB 0755
test_arm_coresight_disasm.sh File 1.97 KB 0755
test_arm_spe.sh File 3.71 KB 0755
test_arm_spe_fork.sh File 1.03 KB 0755
test_brstack.sh File 2.97 KB 0755
test_data_symbol.sh File 1.95 KB 0755
test_intel_pt.sh File 17.2 KB 0755
test_java_symbol.sh File 1.96 KB 0755
test_perf_data_converter_json.sh File 1.32 KB 0755
test_stat_intel_tpebs.sh File 848 B 0755
test_task_analyzer.sh File 4.8 KB 0755
test_uprobe_from_different_cu.sh File 1.63 KB 0755
trace+probe_vfs_getname.sh File 1.45 KB 0755
trace_btf_enum.sh File 1.35 KB 0755
trace_btf_general.sh File 2.03 KB 0755
trace_exit_race.sh File 1.22 KB 0755
Filemanager